=== debian/changelog ===
libdjinterop (0.21.0+ds-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 20 Jul 2024 10:44:40 -0400

libdjinterop (0.21.0+ds-2) unstable; urgency=medium

  * debian/upstream/metadata: Added.

 -- Boyuan Yang <byang@debian.org>  Fri, 12 Jul 2024 16:40:48 -0400

libdjinterop (0.21.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1074001)

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Jun 2024 09:18:52 -0400
