## libdjinterop 0.22.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.10)
 project(libdjinterop
-        VERSION 0.21.0
+        VERSION 0.22.1
         DESCRIPTION "C++ library providing access to DJ record libraries")
 set(PROJECT_HOMEPAGE_URL "https://github.com/xsco/libdjinterop")
 
@@ -26,7 +26,6 @@
 else()
     add_compile_options("$<$<CONFIG:DEBUG>:-Wall>")
 endif()
-
 
 # Build shared a library by default.
 option(BUILD_SHARED_LIBS "Build shared library" ON)
@@ -61,6 +60,8 @@
     src/djinterop/engine/schema/schema_2_20_2.cpp
     src/djinterop/engine/schema/schema_2_20_3.cpp
     src/djinterop/engine/schema/schema_2_21_0.cpp
+    src/djinterop/engine/schema/schema_2_21_1.cpp
+    src/djinterop/engine/schema/schema_2_21_2.cpp
     src/djinterop/engine/schema/schema.cpp
     src/djinterop/engine/v1/engine_crate_impl.cpp
     src/djinterop/engine/v1/engine_database_impl.cpp
@@ -101,10 +102,6 @@
 endif()
 
 # Generate config.hpp based on build-time environment.
-include(CheckIncludeFileCXX)
-CHECK_INCLUDE_FILE_CXX(optional DJINTEROP_STD_OPTIONAL)
-CHECK_INCLUDE_FILE_CXX(experimental/optional DJINTEROP_STD_EXPERIMENTAL_OPTIONAL)
-
 configure_file(
     include/djinterop/config.hpp.in
     include/djinterop/config.hpp)
@@ -170,7 +167,6 @@
     include/djinterop/djinterop.hpp
     include/djinterop/exceptions.hpp
     include/djinterop/musical_key.hpp
-    include/djinterop/optional.hpp
     include/djinterop/pad_color.hpp
     include/djinterop/performance_data.hpp
     include/djinterop/semantic_version.hpp
