=== debian/changelog ===
libdjinterop (0.22.1+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 02 Oct 2024 15:22:04 -0400

libdjinterop (0.22.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/libdjinterop0.shlibs: Added and limit to (>= 0.22.1).

 -- Boyuan Yang <byang@debian.org>  Tue, 01 Oct 2024 20:01:03 -0400
