=== debian/control ===
Source: libdjinterop
Priority: optional
Section: libs
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libboost-dev <!nocheck>,
 libhowardhinnant-date-dev,
 libsqlite3-dev,
 sqlite-modern-cpp-dev,
 zlib1g-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/xsco/libdjinterop
Vcs-Git: https://salsa.debian.org/multimedia-team/libdjinterop.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libdjinterop
Description: C++ library to allow access to DJ record database formats
 The libdjinterop library is a C++ library that allows access to database
 formats used to store information about DJ record libraries.
 .
 This library currently supports:
   - Engine Library, as used on "Prime"-series DJ equipment.

Package: libdjinterop-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 libdjinterop0 (= ${binary:Version}),
Description: ${source:Synopsis} (dev)
 ${source:Extended-Description}
 .
 This package provides the development files for the library.

Package: libdjinterop0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: ${source:Synopsis} (shared library)
 ${source:Extended-Description}
 .
 This package provides the shared library files.
