## libdjinterop 0.24.3+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(libdjinterop
        VERSION 0.24.3
        DESCRIPTION "C++ library providing access to DJ record libraries")
set(PROJECT_HOMEPAGE_URL "https://github.com/xsco/libdjinterop")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

if(POLICY CMP0074)
    # CMP0074: find_package() uses <PackageName>_ROOT variables.
    cmake_policy(SET CMP0074 NEW)
endif()
if(POLICY CMP0076)
    # CMP0076: target_sources() command converts relative paths to absolute.
    cmake_policy(SET CMP0076 NEW)
endif()

# Require C++20
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_EXTENSIONS OFF)
if(MSVC)
    add_compile_options("/W4" "/wd4251" "/wd4275" "$<$<CONFIG:RELEASE>:/O2>")

    # Ask MSVC to populate the __cplusplus macro properly.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
else()
    # Disabling -Wunused-variable needed as the library implementation doesn't
    # use every variable in the public headers.  Is there a better way?
    # Disabling -Wunused-but-set-variable owing to XCode triggering on this
    # in the SQLite amalgamation.
    add_compile_options("-Wall" "-Wpedantic" "-Wno-unused-variable" "-Wno-unused-but-set-variable" "-Werror")
endif()

# Build shared a library by default.
option(BUILD_SHARED_LIBS "Build shared library" ON)

# Option to use either system SQLite or embedded SQLite.
option(SYSTEM_SQLITE "Use system installation of SQLite" ON)

# Require zlib >= 1.2.8
set(ZLIB_MIN_VERSION 1.2.8)
find_package(ZLIB ${ZLIB_MIN_VERSION} REQUIRED)

add_library(
    DjInterop
    include/djinterop/album_art.hpp
    include/djinterop/crate.hpp
    include/djinterop/database.hpp
    include/djinterop/djinterop.hpp
    include/djinterop/engine/engine.hpp
    include/djinterop/engine/engine_schema.hpp
    include/djinterop/engine/v2/beat_data_blob.hpp
    include/djinterop/engine/v2/change_log_table.hpp
    include/djinterop/engine/v2/engine_library.hpp
    include/djinterop/engine/v2/information_table.hpp
    include/djinterop/engine/v2/loops_blob.hpp
    include/djinterop/engine/v2/overview_waveform_data_blob.hpp
    include/djinterop/engine/v2/playlist_entity_table.hpp
    include/djinterop/engine/v2/playlist_table.hpp
    include/djinterop/engine/v2/quick_cues_blob.hpp
    include/djinterop/engine/v2/track_data_blob.hpp
    include/djinterop/engine/v2/track_table.hpp
    include/djinterop/engine/v3/beat_data_blob.hpp
    include/djinterop/engine/v3/engine_library.hpp
    include/djinterop/engine/v3/information_table.hpp
    include/djinterop/engine/v3/loops_blob.hpp
    include/djinterop/engine/v3/overview_waveform_data_blob.hpp
    include/djinterop/engine/v3/performance_data_table.hpp
    include/djinterop/engine/v3/playlist_entity_table.hpp
    include/djinterop/engine/v3/playlist_table.hpp
    include/djinterop/engine/v3/quick_cues_blob.hpp
    include/djinterop/engine/v3/track_data_blob.hpp
    include/djinterop/engine/v3/track_table.hpp
    include/djinterop/exceptions.hpp
    include/djinterop/musical_key.hpp
    include/djinterop/pad_color.hpp
    include/djinterop/performance_data.hpp
    include/djinterop/semantic_version.hpp
    include/djinterop/stream_helper.hpp
    include/djinterop/track.hpp
    include/djinterop/track_snapshot.hpp
    src/djinterop/crate.cpp
    src/djinterop/database.cpp
    src/djinterop/engine/base_engine_library.cpp
    src/djinterop/engine/encode_decode_utils.cpp
    src/djinterop/engine/encode_decode_utils.hpp
    src/djinterop/engine/engine.cpp
    src/djinterop/engine/engine_library_context.hpp
    src/djinterop/engine/engine_library_dir_utils.cpp
    src/djinterop/engine/engine_library_dir_utils.hpp
    src/djinterop/engine/metadata_types.hpp
    src/djinterop/engine/schema/schema_1_6_0.cpp
    src/djinterop/engine/schema/schema_1_6_0.hpp
    src/djinterop/engine/schema/schema_1_7_1.cpp
    src/djinterop/engine/schema/schema_1_7_1.hpp
    src/djinterop/engine/schema/schema_1_9_1.cpp
    src/djinterop/engine/schema/schema_1_9_1.hpp
    src/djinterop/engine/schema/schema_1_11_1.cpp
    src/djinterop/engine/schema/schema_1_11_1.hpp
    src/djinterop/engine/schema/schema_1_13_0.cpp
    src/djinterop/engine/schema/schema_1_13_0.hpp
    src/djinterop/engine/schema/schema_1_13_1.cpp
    src/djinterop/engine/schema/schema_1_13_1.hpp
    src/djinterop/engine/schema/schema_1_13_2.cpp
    src/djinterop/engine/schema/schema_1_13_2.hpp
    src/djinterop/engine/schema/schema_1_15_0.cpp
    src/djinterop/engine/schema/schema_1_15_0.hpp
    src/djinterop/engine/schema/schema_1_17_0.cpp
    src/djinterop/engine/schema/schema_1_17_0.hpp
    src/djinterop/engine/schema/schema_1_18_0_desktop.cpp
    src/djinterop/engine/schema/schema_1_18_0_desktop.hpp
    src/djinterop/engine/schema/schema_1_18_0_os.cpp
    src/djinterop/engine/schema/schema_1_18_0_os.hpp
    src/djinterop/engine/schema/schema_2_18_0.cpp
    src/djinterop/engine/schema/schema_2_18_0.hpp
    src/djinterop/engine/schema/schema_2_20_1.cpp
    src/djinterop/engine/schema/schema_2_20_1.hpp
    src/djinterop/engine/schema/schema_2_20_2.cpp
    src/djinterop/engine/schema/schema_2_20_2.hpp
    src/djinterop/engine/schema/schema_2_20_3.cpp
    src/djinterop/engine/schema/schema_2_20_3.hpp
    src/djinterop/engine/schema/schema_2_21_0.cpp
    src/djinterop/engine/schema/schema_2_21_0.hpp
    src/djinterop/engine/schema/schema_2_21_1.cpp
    src/djinterop/engine/schema/schema_2_21_1.hpp
    src/djinterop/engine/schema/schema_2_21_2.cpp
    src/djinterop/engine/schema/schema_2_21_2.hpp
    src/djinterop/engine/schema/schema_3_0_0.cpp
    src/djinterop/engine/schema/schema_3_0_0.hpp
    src/djinterop/engine/schema/schema.cpp
    src/djinterop/engine/schema/schema.hpp
    src/djinterop/engine/schema/schema_validate_utils.hpp
    src/djinterop/engine/v1/engine_crate_impl.cpp
    src/djinterop/engine/v1/engine_crate_impl.hpp
    src/djinterop/engine/v1/engine_database_impl.cpp
    src/djinterop/engine/v1/engine_database_impl.hpp
    src/djinterop/engine/v1/engine_storage.cpp
    src/djinterop/engine/v1/engine_storage.hpp
    src/djinterop/engine/v1/engine_track_impl.cpp
    src/djinterop/engine/v1/engine_track_impl.hpp
    src/djinterop/engine/v1/performance_data_format.cpp
    src/djinterop/engine/v1/performance_data_format.hpp
    src/djinterop/engine/v2/beat_data_blob.cpp
    src/djinterop/engine/v2/change_log_table.cpp
    src/djinterop/engine/v2/convert_beatgrid.hpp
    src/djinterop/engine/v2/convert_hot_cues.hpp
    src/djinterop/engine/v2/convert_loops.hpp
    src/djinterop/engine/v2/convert_track.hpp
    src/djinterop/engine/v2/convert_waveform.hpp
    src/djinterop/engine/v2/crate_impl.cpp
    src/djinterop/engine/v2/crate_impl.hpp
    src/djinterop/engine/v2/database_impl.cpp
    src/djinterop/engine/v2/database_impl.hpp
    src/djinterop/engine/v2/engine_library.cpp
    src/djinterop/engine/v2/information_table.cpp
    src/djinterop/engine/v2/loops_blob.cpp
    src/djinterop/engine/v2/overview_waveform_data_blob.cpp
    src/djinterop/engine/v2/playlist_entity_table.cpp
    src/djinterop/engine/v2/playlist_table.cpp
    src/djinterop/engine/v2/quick_cues_blob.cpp
    src/djinterop/engine/v2/track_data_blob.cpp
    src/djinterop/engine/v2/track_table.cpp
    src/djinterop/engine/v2/track_impl.cpp
    src/djinterop/engine/v2/track_impl.hpp
    src/djinterop/engine/v3/convert_beatgrid.hpp
    src/djinterop/engine/v3/convert_hot_cues.hpp
    src/djinterop/engine/v3/convert_loops.hpp
    src/djinterop/engine/v3/convert_track.hpp
    src/djinterop/engine/v3/convert_waveform.hpp
    src/djinterop/engine/v3/crate_impl.cpp
    src/djinterop/engine/v3/crate_impl.hpp
    src/djinterop/engine/v3/database_impl.cpp
    src/djinterop/engine/v3/database_impl.hpp
    src/djinterop/engine/v3/engine_library.cpp
    src/djinterop/engine/v3/performance_data_table.cpp
    src/djinterop/engine/v3/track_impl.cpp
    src/djinterop/engine/v3/track_impl.hpp
    src/djinterop/engine/v3/track_table.cpp
    src/djinterop/impl/crate_impl.cpp
    src/djinterop/impl/crate_impl.hpp
    src/djinterop/impl/database_impl.cpp
    src/djinterop/impl/database_impl.hpp
    src/djinterop/impl/track_impl.cpp
    src/djinterop/impl/track_impl.hpp
    src/djinterop/track.cpp
    src/djinterop/util/chrono.cpp
    src/djinterop/util/chrono.hpp
    src/djinterop/util/filesystem.cpp
    src/djinterop/util/filesystem.hpp
    src/djinterop/util/random.cpp
    src/djinterop/util/random.hpp
    src/djinterop/util/sqlite_transaction.hpp
)

set_target_properties(DjInterop PROPERTIES
    OUTPUT_NAME "djinterop"
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR})

target_compile_definitions(DjInterop PUBLIC DJINTEROP_SOURCE)

get_target_property(DJINTEROP_LIBRARY_TYPE DjInterop TYPE)
if(DJINTEROP_LIBRARY_TYPE STREQUAL "STATIC_LIBRARY")
	set(DJINTEROP_STATIC ON)
endif()

# Generate config.hpp based on build-time environment.
configure_file(
    include/djinterop/config.hpp.in
    include/djinterop/config.hpp)

include(GNUInstallDirs)
set(DJINTEROP_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/djinterop")

target_include_directories(
        DjInterop PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${DJINTEROP_INSTALL_INCLUDEDIR}>)
target_include_directories(
        DjInterop PRIVATE SYSTEM
        ${ZLIB_INCLUDE_DIRS}
        ext/sqlite_modern_cpp
        ext/date)

target_link_libraries(
    DjInterop PUBLIC
    ${ZLIB_LIBRARIES})


if(SYSTEM_SQLITE)
    # Search for system installation of SQLite and use that.
    set(SQLITE_MIN_VERSION 3.11)
    find_package(SQLite3 ${SQLITE_MIN_VERSION} REQUIRED)
    target_include_directories(
        DjInterop PRIVATE SYSTEM
        ${SQLite3_INCLUDE_DIRS})
    target_link_libraries(
        DjInterop PUBLIC
        ${SQLite3_LIBRARIES})
else()
    # Use embedded SQLite amalgamation sources.
    message(STATUS "Using embedded SQLite")
    target_sources(
        DjInterop PRIVATE
        ext/sqlite-amalgamation/sqlite3.c)
    target_compile_definitions(
        DjInterop PUBLIC
        SQLITE_OMIT_LOAD_EXTENSION)
    target_include_directories(
        DjInterop PRIVATE SYSTEM
        ext/sqlite-amalgamation)
endif()

set_target_properties(DjInterop PROPERTIES C_VISIBILITY_PRESET hidden)
set_target_properties(DjInterop PROPERTIES CXX_VISIBILITY_PRESET hidden)

install(TARGETS DjInterop
        EXPORT DjInteropTargets
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/include/djinterop/config.hpp
    include/djinterop/album_art.hpp
    include/djinterop/crate.hpp
    include/djinterop/database.hpp
    include/djinterop/djinterop.hpp
    include/djinterop/exceptions.hpp
    include/djinterop/musical_key.hpp
    include/djinterop/pad_color.hpp
    include/djinterop/performance_data.hpp
    include/djinterop/semantic_version.hpp
    include/djinterop/stream_helper.hpp
    include/djinterop/track.hpp
    include/djinterop/track_snapshot.hpp
    DESTINATION "${DJINTEROP_INSTALL_INCLUDEDIR}")
install(FILES
    include/djinterop/engine/engine.hpp
    include/djinterop/engine/engine_schema.hpp
    DESTINATION "${DJINTEROP_INSTALL_INCLUDEDIR}/engine")
install(FILES
    include/djinterop/engine/v2/beat_data_blob.hpp
    include/djinterop/engine/v2/change_log_table.hpp
    include/djinterop/engine/v2/engine_library.hpp
    include/djinterop/engine/v2/information_table.hpp
    include/djinterop/engine/v2/loops_blob.hpp
    include/djinterop/engine/v2/overview_waveform_data_blob.hpp
    include/djinterop/engine/v2/playlist_entity_table.hpp
    include/djinterop/engine/v2/playlist_table.hpp
    include/djinterop/engine/v2/quick_cues_blob.hpp
    include/djinterop/engine/v2/track_data_blob.hpp
