=== debian/changelog ===
libdjinterop (0.24.3+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Aug 2025 11:04:41 -0400

libdjinterop (0.24.3+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/patches: Refresh patches.
  * debian/libdjinterop0.shlibs: Tighten version requirement.

 -- Boyuan Yang <byang@debian.org>  Sat, 25 Jan 2025 18:15:23 -0500
