=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libsqlite3-dev,
  sqlite-modern-cpp-dev,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/xsco/libdjinterop
 Vcs-Git: https://salsa.debian.org/multimedia-team/libdjinterop.git
