=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain,oversionmangle=s/(.*)/$1+ds/,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
 https://api.github.com/repos/xsco/libdjinterop/tags?per_page=100 \
 https://api.github.com/repos/xsco/libdjinterop/tarball/refs/tags/@ANY_VERSION@
